﻿namespace U2UConsult.Metro.DynamicTemplating
{
    using Windows.UI.Xaml;
    using Windows.UI.Xaml.Controls;
    using Windows.UI.Xaml.Markup;

    public class BeerTemplateSelector : DataTemplateSelector
    {
        public DataTemplate DefaultTemplate { get; set; }

        protected override DataTemplate SelectTemplateCore(object item, DependencyObject container)
        {
            Beer beer = item as Beer;

            if (!(beer.Category.Contains("Belgian") || beer.Category.Contains("Flemish")))
            {
                return this.DefaultTemplate;
            }

            BeerColorConverter converter = new BeerColorConverter();
            string backGroundColor = converter.Convert((item as Beer).Color, null, null, null).ToString();

            string template = @"
                <DataTemplate xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation'>
                    <StackPanel Background='" + backGroundColor + @"' Width='360'>
                        <TextBlock Text='{Binding Name}' FontWeight='Bold' Margin='2' Foreground='Black' HorizontalAlignment='center' />
                        <Grid>
                            <TextBlock Text='{Binding Category}' Margin='2' Foreground='Black' />
                            <Image Source='../Assets/belgianFlag.png' Margin='2' HorizontalAlignment='Right' Stretch='None' />
                        </Grid>
                    </StackPanel>
                </DataTemplate>";
            return XamlReader.Load(template) as DataTemplate;
        }
    }
}
